Skip to main content
`Ctrl`+`K`

# TSSetTransientVariable

sets function to transform from state to transient variables

## Synopsis

    #include "petscts.h"
    PetscErrorCode TSSetTransientVariable(TS ts, TSTransientVariableFn *tvar, void *ctx)

Logically Collective

## Input Parameters

- ts - time stepping context on which to change the transient variable

- tvar - a function that transforms to transient variables, see `TSTransientVariableFn` for the calling sequence

- ctx - a context for tvar

## Notes

This is typically used to transform from primitive to conservative variables so that a time integrator (e.g., `TSBDF`) can be conservative. In this context, primitive variables P are used to model the state (e.g., because they lead to well-conditioned formulations even in limiting cases such as low-Mach or zero porosity). The transient variable is C(P), specified by calling this function. An IFunction thus receives arguments (P, Cdot) and the IJacobian must be evaluated via the chain rule, as in

         dF/dP + shift * dF/dCdot dC/dP.

## See Also

TS: Scalable ODE and DAE Solvers, `TS`, `TSBDF`, `TSTransientVariableFn`, `DMTSSetTransientVariable()`, `DMTSGetTransientVariable()`, `TSSetIFunction()`, `TSSetIJacobian()`

## Level

advanced

## Location

src/ts/interface/ts.c

Index of all TS routines
Table of Contents for all manual pages
Index of all manual pages